Index: src/sas/sasgui/plottools/PlotPanel.py
===================================================================
--- src/sas/sasgui/plottools/PlotPanel.py	(revision ef6d1d892f07d724220f6f8b7edb2b8ce676f650)
+++ src/sas/sasgui/plottools/PlotPanel.py	(revision 821c33061f6289c05224e2e044b69efcfd2755a8)
@@ -1223,8 +1223,4 @@
         if prop["ylabel"]:
             self.subplot.set_ylabel(r"$%s$"%prop["ylabel"])
-        if prop["xlim"] is not None:
-            self.subplot.set_xlim(prop["xlim"])
-        if prop["ylim"] is not None:
-            self.subplot.set_ylim(prop["ylim"])
         self.subplot.set_title(prop["title"])
 
@@ -1767,5 +1763,4 @@
         _yscale = 'linear'
         for item in list:
-            set_ylim = False # Whether to set ylim based on data points or error bars
             item.setLabel(self.xLabel, self.yLabel)
             # control axis labels from the panel itself
@@ -1827,5 +1822,4 @@
                 self.graph._yaxis_transformed("1/%s" % yname, "%s" % yunits)
             if self.yLabel == "y*x^(2)":
-                set_ylim = True
                 item.transformY(transform.toYX2, transform.errToYX2)
                 xunits = convert_unit(4, self.xaxis_unit)
@@ -1833,5 +1827,4 @@
                                               "%s%s" % (yunits, xunits))
             if self.yLabel == "y*x^(4)":
-                set_ylim = True
                 item.transformY(transform.toYX4, transform.errToYX4)
                 xunits = convert_unit(4, self.xaxis_unit)
@@ -1864,22 +1857,5 @@
                 self.graph._yaxis_transformed("%s \ \ %s^{4}" % (yname, xname),
                                               "%s%s" % (yunits, xunits))
-            if self.viewModel == "Guinier lny vs x^(2)":
-                item.transformX(transform.toX2, transform.errToX2)
-                xunits = convert_unit(2, xunits)
-                self.graph._xaxis_transformed("%s^{2}" % xname, "%s" % xunits)
-                item.transformY(transform.toLogX, transform.errToLogX)
-                self.graph._yaxis_transformed("\ln\ \ %s" % yname, "%s" % yunits)
-            if self.viewModel == "Porod y*x^(4) vs x^(4)":
-                item.transformX(transform.toX4, transform.errToX4)
-                xunits = convert_unit(4, self.xaxis_unit)
-                self.graph._xaxis_transformed("%s^{4}" % xname, "%s" % xunits)
-                item.transformY(transform.toYX4, transform.errToYX4)
-                self.graph._yaxis_transformed("%s \ \ %s^{4}" % (yname, xname),
-                                              "%s%s" % (yunits, xunits))
             item.transformView()
-            if set_ylim:
-                self.graph.ylim((min(item.view.y), max(item.view.y)))
-            else:
-                self.graph.ylim(None)
 
         # set new label and units
Index: src/sas/sasgui/plottools/plottables.py
===================================================================
--- src/sas/sasgui/plottools/plottables.py	(revision aa6028c755151d0902c6747f2f27a96c3667bb9a)
+++ src/sas/sasgui/plottools/plottables.py	(revision 821c33061f6289c05224e2e044b69efcfd2755a8)
@@ -157,10 +157,4 @@
         self.prop["xunit_base"] = units
 
-    def xlim(self, xlim):
-        """
-        Set the limits of the x axis to (min, max).
-        """
-        self.prop["xlim"] = xlim
-
     def yaxis(self, name, units):
         """
@@ -173,10 +167,4 @@
         self.prop["ylabel_base"] = name
         self.prop["yunit_base"] = units
-
-    def ylim(self, ylim):
-        """
-        Set the limits of the y axis to (min, max).
-        """
-        self.prop["ylim"] = ylim
 
     def title(self, name):
@@ -278,5 +266,4 @@
         self.prop = {"xlabel": "", "xunit": None,
                      "ylabel": "", "yunit": None,
-                     "xlim": None, "ylim": None,
                      "title": ""}
         self.plottables = {}
Index: src/sas/sasgui/plottools/transform.py
===================================================================
--- src/sas/sasgui/plottools/transform.py	(revision d7bb5267934b5676c90b1655346a3793a8022965)
+++ src/sas/sasgui/plottools/transform.py	(revision 821c33061f6289c05224e2e044b69efcfd2755a8)
@@ -291,5 +291,5 @@
 
 
-def errToYX2(x, y, dx=None, dy=None):
+def errToYX2(y, x, dy=None, dx=None):
     """
     """
@@ -325,5 +325,5 @@
 
 
-def errToLogYX2(x, y, dx=None, dy=None):
+def errToLogYX2(y, x, dy=None, dx=None):
     """
     calculate error of Log(yx**2)
@@ -375,5 +375,5 @@
 
 
-def errToLogYX4(x, y=None, dx=None, dy=None):
+def errToLogYX4(y, x, dy=None, dx=None):
     """
     error for ln(y*x^(4))
@@ -396,5 +396,5 @@
 
 
-def errToYX4(x, y=None, dx=None, dy=None):
+def errToYX4(y, x, dy=None, dx=None):
     """
     error for (y*x^(4))